unit UVaz;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, FileCtrl;

type
  TForm1 = class(TForm)
    Kep: TImage;
    btnKilep: TButton;
    Button1: TButton;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    FilterComboBox1: TFilterComboBox;
    procedure btnKilepClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    Procedure KepKiolvasas;
    procedure FileListBox1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
// const    n=300; m=300;  n=100; m=100;  n=485; m=287;  n=315; m=500;
var
  Form1: TForm1;
  KepM, KepUj   : Array [0..1000,0..1000] of byte;
  i,j, n, m : integer;
implementation

{$R *.dfm}

Function Hatar(i,j:integer):boolean;
const    sz : array [1..9,1..2] of integer =((0,1),(1,1),(1,0),(1,-1),
                                            (0,-1),(-1,-1),(-1,0),(-1,1),(0,1));
var      k, l, c : integer;

begin
   c:=0;
   Repeat
         Inc(c);
         k:=i+sz[c,1];
         l:=j+sz[c,2];

   Until (c>8) or (KepM[k,l]=0);
   Hatar:=c<=8;
end;

Function Feltetel(i,j,lepes:integer):boolean;
const    sz : array [1..9,1..2] of integer =((0,1),(1,1),(1,0),(1,-1),
                                            (0,-1),(-1,-1),(-1,0),(-1,1),(0,1));
var       s, k, l, c, valt : integer;
          iii, iv : boolean;
begin
   s:=0; valt:=0;
   For c:=1 to 8 do
   begin
         k:=i+sz[c,1];
         l:=j+sz[c,2];
         s:=s+KepM[k,l];
         if (KepM[k,l]=0) and (KepM[i+sz[c+1,1],j+sz[c+1,2]]=1) then Inc(valt);
   end;

   if lepes=1 then
              begin
               iii:=  (KepM[i+sz[1,1],j+sz[1,2]]*KepM[i+sz[3,1],j+sz[3,2]]*
                       KepM[i+sz[5,1],j+sz[5,2]])=0;
                iv:=  (KepM[i+sz[3,1],j+sz[3,2]]*KepM[i+sz[5,1],j+sz[5,2]]*
                       KepM[i+sz[7,1],j+sz[7,2]])=0;
               end
              else
              begin
               iii:=  (KepM[i+sz[1,1],j+sz[1,2]]*KepM[i+sz[3,1],j+sz[3,2]]*
                       KepM[i+sz[7,1],j+sz[7,2]])=0;
                iv:=  (KepM[i+sz[1,1],j+sz[1,2]]*KepM[i+sz[5,1],j+sz[5,2]]*
                       KepM[i+sz[7,1],j+sz[7,2]])=0;
              end;
   Feltetel:= (2<=s) and (s<=6) and (valt=1) and iii and iv;
end;

Procedure Sovanyitas;
Var Vege : boolean;
begin
    Repeat
       Vege:=True;
       For i:=1 to n do
         For j:=1 to m do
         begin
            If (KepM[i,j]=1) and Hatar(i,j) and Feltetel(i,j,1)
             then begin
                      KepUj[i,j]:=0;
                      Vege:=False;
                  end
             else  KepUj[i,j]:=KepM[i,j];
         end;
       KepM:=KepUj;
       For i:=1 to n do
         For j:=1 to m do
         begin
            If (KepM[i,j]=1) and Hatar(i,j) and Feltetel(i,j,2)
             then begin
                      KepUj[i,j]:=0;
                      Vege:=False;
                  end
             else  KepUj[i,j]:=KepM[i,j];
         end;
       KepM:=KepUj;
    Until Vege;
end;

Procedure Rajz;
Var tav, S : integer;
begin
   For i:=1 to n do
      For j:=1 to m do
       if KepM[i,j]<>0 then
               Form1.Kep.Canvas.Pixels[i,j]:=clWhite;
end;

procedure TForm1.btnKilepClick(Sender: TObject);
begin
  Application.Terminate;
end;

Procedure TForm1.KepKiolvasas;
begin

  For i:=0 to n+1 do  begin KepM[i,0]:=0; KepM[i,m+1]:=0; end;
  For j:=0 to m+1 do  begin KepM[0,j]:=0; KepM[n+1,j]:=0; end;
  For i:=1 to n do
    For j:=1 to m do
        if Kep.Canvas.Pixels[i,j]=clBlack then KepM[i,j]:=1 else KepM[i,j]:=0;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    Form1.KepKiolvasas;
    Sovanyitas;
    Rajz;
end;

procedure TForm1.FileListBox1DblClick(Sender: TObject);
begin
  Kep.Picture.LoadFromFile(FileListBox1.FileName);
  n:=Kep.Picture.Width;
  m:=Kep.Picture.Height;
end;

end.
